;|
Dominique VAQUAND
20.02.2020
=====================================================
Trace un trait d'axe sur des conduites de tuyauteries
=====================================================
|;


(defun c:AP3D_AxesT (/	Selection  CalqueCourant
		     	Osmode	OBJ	   OBJ_1      OBJ_2
		     	X_LignesAxes	   PT_10      Index_S
		     	Index	PT_S1	   PT_S2      PT_S3
		    )

; Slection des objets PLANT 3D
  (setq Selection (ssget (list (cons 0 "ACPPP*,ACPPC*"))))


  (setq Index_S 0)

; Si des objets sont slectionns
  
  (if Selection

    (progn

; Mmorisation des paramtres de dpart
      
      (setq CalqueCourant (getvar "clayer"))
      (setq Osmode (getvar "osmode"))
      (setvar "osmode" 0)
      (command "_ucs" "")
      
; Gestiion Erreur
      
      (defun *error* (s)
	(setvar "osmode" osmode)
	(setvar "clayer" CalqueCourant)
	(command "_UCS" "_p")
	(setq *error* nil)
      )

; Cration du calque AP3D_Axes_Tuyauterie s'il n'existe pas ou met courant ce calque
      (if (= (tblsearch "layer" "AP3D_Axes_Tuyauterie"))
	(command "_layer" "_T" "AP3D_Axes_Tuyauterie" "_UN" "AP3D_Axes_Tuyauterie" "")
      )

      (command "_layer" "_m" "AP3D_Axes_Tuyauterie" "_co" "1" "" "" )

; Boucle sur le nombre d'objet PLANT 3D slectionns

      (repeat (sslength Selection)

	; rcupration des codes DXF primaires

	(setq OBJ (entget (ssname Selection Index_S)))

	; Mmorisation de la coordonne dpart ou point d'insertion
	(setq PT_10 (cdr (assoc 10 (reverse OBJ))))

	; Mmorisatiobn des pointeurs
	(setq OBJ_1 (entget (cdr (assoc 330 OBJ))))

	; traitement pour tracer la ligne d'axe

	(TraiteObj obj_1 360 obj PT_10)


	(setq index_S (1+ index_S))

      )	;repeat
    )
  ) ;if

  ; Les lignes d'axes ont t cres, on les joint ensemble pour crer des polylignes 2D ou 3D

  (setq	X_LignesAxes
	 (ssget	"x"
		(list (cons 0 "LINE")
		      (cons 8 "AP3D_Axes_Tuyauterie")
		)
	 )
  )
  (initcommandversion)
  (command "_join" X_LignesAxes "")

; Remise des paramtres de dpart

  (setvar "osmode" osmode)
  (setvar "clayer" CalqueCourant)
  (command "_UCS" "_p")

  (princ)
)

;|
==========================
Cration des lignes d'axe 
==========================
|;

(defun TraiteObj (Obj1x	   Codedxf  objx     PT_10x   /	       PT_S1
		  PT_S2	   PT_S3    PT_S4    PT_S5    PT_S6    index
		  OBJ_2
		 )


  ;; Tyuyau = (0 . "ACPPPIPE")
  ;; PT_10 et PT_11 existe

  ;; Composants = (0 . "ACPPPIPEINLINEASSET") ou (0 . "ACPPCONNECTOR")

  (setq index 0)
  (setq	PT_S1 nil
	PT_S2 nil
	PT_S3 nil
	PT_S4 nil
	PT_S5 nil
	PT_S6 nil
  )

  ; si l'objet PLANT 3D est un tuyau on rcupre les coordonnes des ports S1 et S2
  ; directement dals la liste des cls primaires

  (if (= (cdr (assoc 0 objx)) "ACPPPIPE")
    (progn
      (setq pt_s1 (cdr (assoc 10 (reverse objx)))
	    pt_s2 (cdr (assoc 11 (reverse objx)))
      )
      (if (> (distance pt_s1 pt_s2) 0)
	(command "_line" pt_s1 pt_s2 "")
      )
    )

  ; Sinon on recherche les ports S1, S2, ... depuis un nouveau pointeur
  ; une fois les ports S1, S2, ... trouvs on rcupre la coordonnes du port  
    (progn

      (setq OBJ_2 (entget (cdr (assoc Codedxf OBJ1x))))

  ; on boucle sur la liste pour rcuprer la coordonnes du port    

      (repeat (length OBJ_2)

	(if (= (cdr (nth index OBJ_2)) "S1")
	  (if (= PT_S1 nil)
	    (setq PT_S1 (cdr (nth (1+ index) OBJ_2)))
	  )
	)

	(if (= (cdr (nth index OBJ_2)) "S2")
	  (if (= PT_S2 nil)
	    (setq PT_S2 (cdr (nth (1+ index) OBJ_2)))
	  )
	)

	(if (= (cdr (nth index OBJ_2)) "S3")
	  (if (= PT_S3 nil)
	    (setq PT_S3 (cdr (nth (1+ index) OBJ_2)))
	  )
	)

	(if (= (cdr (nth index OBJ_2)) "S4")
	  (if (= PT_S4 nil)
	    (setq PT_S4 (cdr (nth (1+ index) OBJ_2)))
	  )
	)

	(if (= (cdr (nth index OBJ_2)) "S5")
	  (if (= PT_S5 nil)
	    (setq PT_S5 (cdr (nth (1+ index) OBJ_2)))
	  )
	)

	(if (= (cdr (nth index OBJ_2)) "S6")
	  (if (= PT_S6 nil)
	    (setq PT_S6 (cdr (nth (1+ index) OBJ_2)))
	  )
	)

	(setq index (1+ index))

      )	;repeat

; Si la coordonne du port existe alors on trace une ligne d'axe
; du point d'insertion ou point du port

      (if (and (/= pt_s1 nil) (> (distance pt_10 pt_s1) 0))
	(command "_line" pt_10 pt_s1 "")
      )

      (if (and (/= pt_s2 nil) (> (distance pt_10 pt_s2) 0))
	(command "_line" pt_10 pt_s2 "")
      )

      (if (and (/= pt_s3 nil) (> (distance pt_10 pt_s3) 0))
	(command "_line" pt_10 pt_s3 "")
      )

      (if (and (/= pt_s4 nil) (> (distance pt_10 pt_s4) 0))
	(command "_line" pt_10 pt_s4 "")
      )


      (if (and (/= pt_s5 nil) (> (distance pt_10 pt_s5) 0))
	(command "_line" pt_10 pt_s5 "")
      )

      (if (and (/= pt_s6 nil) (> (distance pt_10 pt_s6) 0))
	(command "_line" pt_10 pt_s6 "")
      )

    )
  ) ;if

(princ)

) ;defun


;|
Efface tous les objets placs sur le calque "AP3D_Axes_Tuyauterie"
|;

(defun c:AP3D_EffacerAxesT ()

  (command "_erase"
	   (ssget "x" (list (cons 8 "AP3D_Axes_Tuyauterie")))
	   ""
  )
  (princ)
)
